import LSystem
import Test.QuickCheck
import System.Environment

spiral :: Distance -> Integer -> Distance -> Angle -> Command
spiral side n step angle
 | n == 0   = Sit
 | n <  100   = GrabPen (Colour 0 0.5 0)
               :#:(Go side :#: Turn angle
               :#: spiral (side + step) (n-1) step angle)
               
 | n < 220 && n > 212  = GrabPen (Colour 0 0 0.8)
               :#:(Go side :#: Turn angle
               :#: spiral (side + step) (n-1) step angle)
                           
 |otherwise = GrabPen (Colour red 0 0)
               :#:(Go side :#: Turn angle
               :#: spiral (side + step) (n-1) step angle)
               where red = abs 0.2 * (sin 2 * (fromIntegral n))
                     
flower :: Integer -> Int -> Float -> Command
flower count x seed = f x seed
    where
       f 0 seed = GrabPen red :#: Go 10
       f x seed = spiral 0.1 count 0.1 4 :#: Go (3* seed) :#: Turn seed :#: f (x - 1) (seed * (-1)) 

main = do
        args <- getArgs
        let count = ((map read args)!!0)
        display (flower count 800 45)

                     

p1 = display (flower 858 800 45 )
p2 = display (flower 390 800 45 )
p3 = display (flower 389 800 45 )
p4 = display (flower 389 800 30 )
